diff --git a/gcc/config/pa/pa.c b/gcc/config/pa/pa.c
index fb698d2..e180dd2 100644
--- a/gcc/config/pa/pa.c
+++ b/gcc/config/pa/pa.c
@@ -464,7 +464,7 @@ fix_range (const char *const_str)
       break;
 
   if (i > FP_REG_LAST)
-    target_flags |= MASK_DISABLE_FPREGS;
+    GCC_OPTION (target_flags) |= MASK_DISABLE_FPREGS;
 }
 
 /* Implement the TARGET_OPTION_OVERRIDE hook.  */
@@ -475,7 +475,7 @@ pa_option_override (void)
   unsigned int i;
   cl_deferred_option *opt;
   vec<cl_deferred_option> *v
-    = (vec<cl_deferred_option> *) pa_deferred_options;
+    = (vec<cl_deferred_option> *) GCC_OPTION (pa_deferred_options);
 
   if (v)
     FOR_EACH_VEC_ELT (*v, i, opt)
@@ -494,43 +494,43 @@ pa_option_override (void)
   /* Unconditional branches in the delay slot are not compatible with dwarf2
      call frame information.  There is no benefit in using this optimization
      on PA8000 and later processors.  */
-  if (pa_cpu >= PROCESSOR_8000
+  if (GCC_OPTION (pa_cpu) >= PROCESSOR_8000
       || (targetm_common.except_unwind_info (&global_options) == UI_DWARF2
-	  && flag_exceptions)
-      || flag_unwind_tables)
-    target_flags &= ~MASK_JUMP_IN_DELAY;
+	  && GCC_OPTION (flag_exceptions))
+      || GCC_OPTION (flag_unwind_tables))
+    GCC_OPTION (target_flags) &= ~MASK_JUMP_IN_DELAY;
 
-  if (flag_pic && TARGET_PORTABLE_RUNTIME)
+  if (GCC_OPTION (flag_pic) && TARGET_PORTABLE_RUNTIME)
     {
       warning (0, "PIC code generation is not supported in the portable runtime model");
     }
 
-  if (flag_pic && TARGET_FAST_INDIRECT_CALLS)
+  if (GCC_OPTION (flag_pic) && TARGET_FAST_INDIRECT_CALLS)
    {
       warning (0, "PIC code generation is not compatible with fast indirect calls");
    }
 
-  if (! TARGET_GAS && write_symbols != NO_DEBUG)
+  if (! TARGET_GAS && GCC_OPTION (write_symbols) != NO_DEBUG)
     {
       warning (0, "-g is only supported when using GAS on this processor,");
       warning (0, "-g option disabled");
-      write_symbols = NO_DEBUG;
+      GCC_OPTION (write_symbols) = NO_DEBUG;
     }
 
   /* We only support the "big PIC" model now.  And we always generate PIC
      code when in 64bit mode.  */
-  if (flag_pic == 1 || TARGET_64BIT)
-    flag_pic = 2;
+  if (GCC_OPTION (flag_pic) == 1 || TARGET_64BIT)
+    GCC_OPTION (flag_pic) = 2;
 
   /* Disable -freorder-blocks-and-partition as we don't support hot and
      cold partitioning.  */
-  if (flag_reorder_blocks_and_partition)
+  if (GCC_OPTION (flag_reorder_blocks_and_partition))
     {
       inform (input_location,
               "-freorder-blocks-and-partition does not work "
               "on this architecture");
-      flag_reorder_blocks_and_partition = 0;
-      flag_reorder_blocks = 1;
+      GCC_OPTION (flag_reorder_blocks_and_partition) = 0;
+      GCC_OPTION (flag_reorder_blocks) = 1;
     }
 
   /* We can't guarantee that .dword is available for 32-bit targets.  */
@@ -919,7 +919,7 @@ legitimize_tls_address (rtx addr)
     {
       case TLS_MODEL_GLOBAL_DYNAMIC:
 	tmp = gen_reg_rtx (Pmode);
-	if (flag_pic)
+	if (GCC_OPTION (flag_pic))
 	  emit_insn (gen_tgd_load_pic (tmp, addr));
 	else
 	  emit_insn (gen_tgd_load (tmp, addr));
@@ -930,7 +930,7 @@ legitimize_tls_address (rtx addr)
 	ret = gen_reg_rtx (Pmode);
 	tmp = gen_reg_rtx (Pmode);
 	start_sequence ();
-	if (flag_pic)
+	if (GCC_OPTION (flag_pic))
 	  emit_insn (gen_tld_load_pic (tmp, addr));
 	else
 	  emit_insn (gen_tld_load (tmp, addr));
@@ -949,7 +949,7 @@ legitimize_tls_address (rtx addr)
 	tmp = gen_reg_rtx (Pmode);
 	ret = gen_reg_rtx (Pmode);
 	emit_insn (gen_tp_load (tp));
-	if (flag_pic)
+	if (GCC_OPTION (flag_pic))
 	  emit_insn (gen_tie_load_pic (tmp, addr));
 	else
 	  emit_insn (gen_tie_load (tmp, addr));
@@ -1038,7 +1038,7 @@ hppa_legitimize_address (rtx x, rtx oldx ATTRIBUTE_UNUSED,
 
   if (pa_tls_referenced_p (x))
     return legitimize_tls_address (x);
-  else if (flag_pic)
+  else if (GCC_OPTION (flag_pic))
     return legitimize_pic_address (x, mode, gen_reg_rtx (Pmode));
 
   /* Strip off CONST.  */
@@ -1953,7 +1953,7 @@ pa_emit_move_sequence (rtx *operands, enum machine_mode mode, rtx scratch_reg)
 		     was originally given to us.  */
 		  scratch_reg = force_mode (word_mode, scratch_reg);
 		}
-	      else if (flag_pic)
+	      else if (GCC_OPTION (flag_pic))
 		scratch_reg = gen_reg_rtx (Pmode);
 
 	      if (GET_CODE (operand1) == CONST)
@@ -1978,7 +1978,7 @@ pa_emit_move_sequence (rtx *operands, enum machine_mode mode, rtx scratch_reg)
 	      /* Get the address of the memory location.  PIC-ify it if
 		 necessary.  */
 	      temp = XEXP (temp, 0);
-	      if (flag_pic)
+	      if (GCC_OPTION (flag_pic))
 		temp = legitimize_pic_address (temp, mode, scratch_reg);
 
 	      /* Put the address of the memory location into our destination
@@ -1998,7 +1998,7 @@ pa_emit_move_sequence (rtx *operands, enum machine_mode mode, rtx scratch_reg)
 	      return 1;
 	    }
 
-	  if (flag_pic)
+	  if (GCC_OPTION (flag_pic))
 	    {
 	      rtx temp;
 
@@ -2021,7 +2021,7 @@ pa_emit_move_sequence (rtx *operands, enum machine_mode mode, rtx scratch_reg)
 		       && GET_CODE (XEXP (XEXP (operand1, 0), 1)) == CONST_INT
 		       && !INT_14_BITS (XEXP (XEXP (operand1, 0), 1))
 		       && (reload_completed || reload_in_progress)
-		       && flag_pic)
+		       && GCC_OPTION (flag_pic))
 		{
 		  rtx const_mem = force_const_mem (mode, operand1);
 		  operands[1] = legitimize_pic_address (XEXP (const_mem, 0),
@@ -3318,7 +3318,7 @@ remove_useless_addtr_insns (int check_notes)
   static int pass = 0;
 
   /* This is fairly cheap, so always run it when optimizing.  */
-  if (optimize > 0)
+  if (GCC_OPTION (optimize) > 0)
     {
       int fcmp_count = 0;
       int fbranch_count = 0;
@@ -3811,7 +3811,7 @@ pa_expand_prologue (void)
     local_fsize += STARTING_FRAME_OFFSET;
 
   actual_fsize = pa_compute_frame_size (size, &save_fregs);
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = actual_fsize;
 
   /* Compute a few things we will use often.  */
@@ -4007,7 +4007,7 @@ pa_expand_prologue (void)
      
      We don't want a note on this insn as the frame marker can
      move if there is a dynamic stack allocation.  */
-  if (flag_pic && actual_fsize != 0 && !TARGET_64BIT)
+  if (GCC_OPTION (flag_pic) && actual_fsize != 0 && !TARGET_64BIT)
     {
       rtx addr = gen_rtx_PLUS (word_mode, stack_pointer_rtx, GEN_INT (-32));
 
@@ -4665,7 +4665,7 @@ pa_adjust_cost (rtx insn, rtx link, rtx dep_insn, int cost)
 
   /* Don't adjust costs for a pa8000 chip, also do not adjust any
      true dependencies as they are described with bypasses now.  */
-  if (pa_cpu >= PROCESSOR_8000 || REG_NOTE_KIND (link) == 0)
+  if (GCC_OPTION (pa_cpu) >= PROCESSOR_8000 || REG_NOTE_KIND (link) == 0)
     return cost;
 
   if (! recog_memoized (insn))
@@ -4882,7 +4882,7 @@ pa_adjust_priority (rtx insn, int priority)
 static int
 pa_issue_rate (void)
 {
-  switch (pa_cpu)
+  switch (GCC_OPTION (pa_cpu))
     {
     case PROCESSOR_700:		return 1;
     case PROCESSOR_7100:	return 2;
@@ -5378,7 +5378,7 @@ pa_output_global_address (FILE *file, rtx x, int round_constant)
 
   if (GET_CODE (x) == SYMBOL_REF && read_only_operand (x, VOIDmode))
     output_addr_const (file, x);
-  else if (GET_CODE (x) == SYMBOL_REF && !flag_pic)
+  else if (GET_CODE (x) == SYMBOL_REF && !GCC_OPTION (flag_pic))
     {
       output_addr_const (file, x);
       fputs ("-$global$", file);
@@ -5448,7 +5448,7 @@ pa_output_global_address (FILE *file, rtx x, int round_constant)
 	  gcc_unreachable ();
 	}
       
-      if (!read_only_operand (base, VOIDmode) && !flag_pic)
+      if (!read_only_operand (base, VOIDmode) && !GCC_OPTION (flag_pic))
 	fputs ("-$global$", file);
       if (offset)
 	fprintf (file, "%s%d", sep, offset);
@@ -5480,7 +5480,7 @@ pa_file_start_space (int sortspace)
   if (sortspace)
     aputs (",SORT=16");
   aputs ("\n\t.SUBSPA $DATA$,QUAD=1,ALIGN=8,ACCESS=31");
-  if (flag_tm)
+  if (GCC_OPTION (flag_tm))
     aputs ("\n\t.SUBSPA $TM_CLONE_TABLE$,QUAD=1,ALIGN=8,ACCESS=31");
   aputs ("\n\t.SUBSPA $BSS$,QUAD=1,ALIGN=8,ACCESS=31,ZERO,SORT=82"
 	 "\n\t.SPACE $TEXT$");
@@ -5493,9 +5493,9 @@ pa_file_start_space (int sortspace)
 static inline void
 pa_file_start_file (int want_version)
 {
-  if (write_symbols != NO_DEBUG)
+  if (GCC_OPTION (write_symbols) != NO_DEBUG)
     {
-      output_file_directive (asm_out_file, main_input_filename);
+      output_file_directive (asm_out_file, GCC_OPTION (main_input_filename));
       if (want_version)
 	aputs ("\t.version\t\"01.01\"\n");
     }
@@ -5504,7 +5504,7 @@ pa_file_start_file (int want_version)
 static inline void
 pa_file_start_mcount (const char *aswhat)
 {
-  if (profile_flag)
+  if (GCC_OPTION (profile_flag))
     fprintf (asm_out_file, "\t.IMPORT _mcount,%s\n", aswhat);
 }
   
@@ -5540,7 +5540,7 @@ pa_hpux64_gas_file_start (void)
 {
   pa_file_start_level ();
 #ifdef ASM_OUTPUT_TYPE_DIRECTIVE
-  if (profile_flag)
+  if (GCC_OPTION (profile_flag))
     ASM_OUTPUT_TYPE_DIRECTIVE (asm_out_file, "_mcount", "function");
 #endif
   pa_file_start_file (1);
@@ -5609,7 +5609,7 @@ output_deferred_plabels (void)
      before outputting the deferred plabels.  */
   if (n_deferred_plabels)
     {
-      switch_to_section (flag_pic ? data_section : readonly_data_section);
+      switch_to_section (GCC_OPTION (flag_pic) ? data_section : readonly_data_section);
       ASM_OUTPUT_ALIGN (asm_out_file, TARGET_64BIT ? 3 : 2);
     }
 
@@ -5931,7 +5931,7 @@ pa_secondary_reload (bool in_p, rtx x, reg_class_t rclass_i,
      generation requires %r1 as a scratch register.  For float modes,
      the only legitimate constant is CONST0_RTX.  However, there are
      a few patterns that accept constant double operands.  */
-  if (flag_pic
+  if (GCC_OPTION (flag_pic)
       && FP_REG_CLASS_P (rclass)
       && (GET_CODE (x) == CONST_INT || GET_CODE (x) == CONST_DOUBLE))
     {
@@ -5967,7 +5967,7 @@ pa_secondary_reload (bool in_p, rtx x, reg_class_t rclass_i,
       if (GET_CODE (x) == HIGH)
 	x = XEXP (x, 0);
 
-      if (flag_pic || !read_only_operand (x, VOIDmode))
+      if (GCC_OPTION (flag_pic) || !read_only_operand (x, VOIDmode))
 	{
 	  switch (mode)
 	    {
@@ -6647,7 +6647,7 @@ pa_output_lbranch (rtx dest, rtx insn, int xdelay)
       gcc_assert (! JUMP_P (NEXT_INSN (insn)));
 
       final_scan_insn (NEXT_INSN (insn), asm_out_file,
-		       optimize, 0, NULL);
+		       GCC_OPTION (optimize), 0, NULL);
 
       /* Now delete the delay insn.  */
       SET_INSN_DELETED (NEXT_INSN (insn));
@@ -6704,7 +6704,7 @@ pa_output_lbranch (rtx dest, rtx insn, int xdelay)
       output_asm_insn ("ldo R'%0(%%r1),%%r1", xoperands);
       output_asm_insn ("bv %%r0(%%r1)", xoperands);
     }
-  else if (flag_pic)
+  else if (GCC_OPTION (flag_pic))
     {
       output_asm_insn ("{bl|b,l} .+8,%%r1", xoperands);
       if (TARGET_SOM || !TARGET_GAS)
@@ -7520,7 +7520,7 @@ pa_attr_length_millicode_call (rtx insn)
 
   if (TARGET_64BIT)
     {
-      if (!TARGET_LONG_CALLS && distance < 7600000)
+      if (!GCC_OPTION (TARGET_LONG_CALLS) && distance < 7600000)
 	return 8;
 
       return 20;
@@ -7529,10 +7529,10 @@ pa_attr_length_millicode_call (rtx insn)
     return 24;
   else
     {
-      if (!TARGET_LONG_CALLS && distance < MAX_PCREL17F_OFFSET)
+      if (!GCC_OPTION (TARGET_LONG_CALLS) && distance < MAX_PCREL17F_OFFSET)
 	return 8;
 
-      if (!flag_pic)
+      if (!GCC_OPTION (flag_pic))
 	return 12;
 
       return 24;
@@ -7561,7 +7561,7 @@ pa_output_millicode_call (rtx insn, rtx call_dest)
      form of the $$sh_func_adrs call has a length of 28.  Because it
      has an attribute type of sh_func_adrs, it never has a nonzero
      sequence length (i.e., the delay slot is never filled).  */
-  if (!TARGET_LONG_CALLS
+  if (!GCC_OPTION (TARGET_LONG_CALLS)
       && (attr_length == 8
 	  || (attr_length == 28
 	      && get_attr_type (insn) == TYPE_SH_FUNC_ADRS)))
@@ -7612,7 +7612,7 @@ pa_output_millicode_call (rtx insn, rtx call_dest)
 	  /* Jump to our target address in %r1.  */
 	  output_asm_insn ("bv %%r0(%%r1)", xoperands);
 	}
-      else if (!flag_pic)
+      else if (!GCC_OPTION (flag_pic))
 	{
 	  output_asm_insn ("ldil L'%0,%%r1", xoperands);
 	  if (TARGET_PA_20)
@@ -7738,7 +7738,7 @@ pa_attr_length_call (rtx insn, int sibcall)
   local_call = call_decl && targetm.binds_local_p (call_decl);
 
   /* pc-relative branch.  */
-  if (!TARGET_LONG_CALLS
+  if (!GCC_OPTION (TARGET_LONG_CALLS)
       && ((TARGET_PA_20 && !sibcall && distance < 7600000)
 	  || distance < MAX_PCREL17F_OFFSET))
     length += 8;
@@ -7748,7 +7748,7 @@ pa_attr_length_call (rtx insn, int sibcall)
     length += sibcall ? 28 : 24;
 
   /* non-pic long absolute branch sequence.  */
-  else if ((TARGET_LONG_ABS_CALL || local_call) && !flag_pic)
+  else if ((TARGET_LONG_ABS_CALL || local_call) && !GCC_OPTION (flag_pic))
     length += 12;
 
   /* long pc-relative branch sequence.  */
@@ -7758,7 +7758,7 @@ pa_attr_length_call (rtx insn, int sibcall)
     {
       length += 20;
 
-      if (!TARGET_PA_20 && !TARGET_NO_SPACE_REGS && (!local_call || flag_pic))
+      if (!TARGET_PA_20 && !TARGET_NO_SPACE_REGS && (!local_call || GCC_OPTION (flag_pic)))
 	length += 8;
     }
 
@@ -7770,7 +7770,7 @@ pa_attr_length_call (rtx insn, int sibcall)
       if (TARGET_SOM)
 	length += length_fp_args (insn);
 
-      if (flag_pic)
+      if (GCC_OPTION (flag_pic))
 	length += 4;
 
       if (!TARGET_PA_20)
@@ -7778,7 +7778,7 @@ pa_attr_length_call (rtx insn, int sibcall)
 	  if (!sibcall)
 	    length += 8;
 
-	  if (!TARGET_NO_SPACE_REGS && (!local_call || flag_pic))
+	  if (!TARGET_NO_SPACE_REGS && (!local_call || GCC_OPTION (flag_pic)))
 	    length += 8;
 	}
     }
@@ -7806,7 +7806,7 @@ pa_output_call (rtx insn, rtx call_dest, int sibcall)
   /* Handle the common case where we're sure that the branch will reach
      the beginning of the "$CODE$" subspace.  This is the beginning of
      the current function if we are in a named section.  */
-  if (!TARGET_LONG_CALLS && pa_attr_length_call (insn, sibcall) == 8)
+  if (!GCC_OPTION (TARGET_LONG_CALLS) && pa_attr_length_call (insn, sibcall) == 8)
     {
       xoperands[1] = gen_rtx_REG (word_mode, sibcall ? 0 : 2);
       output_asm_insn ("{bl|b,l} %0,%1", xoperands);
@@ -7829,7 +7829,7 @@ pa_output_call (rtx insn, rtx call_dest, int sibcall)
 	      && !sibcall)
 	    {
 	      final_scan_insn (NEXT_INSN (insn), asm_out_file,
-			       optimize, 0, NULL);
+			       GCC_OPTION (optimize), 0, NULL);
 
 	      /* Now delete the delay insn.  */
 	      SET_INSN_DELETED (NEXT_INSN (insn));
@@ -7861,7 +7861,7 @@ pa_output_call (rtx insn, rtx call_dest, int sibcall)
 	  /* Emit a long call.  There are several different sequences
 	     of increasing length and complexity.  In most cases,
              they don't allow an instruction in the delay slot.  */
-	  if (!((TARGET_LONG_ABS_CALL || local_call) && !flag_pic)
+	  if (!((TARGET_LONG_ABS_CALL || local_call) && !GCC_OPTION (flag_pic))
 	      && !TARGET_LONG_PIC_SDIFF_CALL
 	      && !(TARGET_GAS && !TARGET_SOM
 		   && (TARGET_LONG_PIC_PCREL_CALL || local_call))
@@ -7873,12 +7873,12 @@ pa_output_call (rtx insn, rtx call_dest, int sibcall)
 	      && !sibcall
 	      && (!TARGET_PA_20
 		  || indirect_call
-		  || ((TARGET_LONG_ABS_CALL || local_call) && !flag_pic)))
+		  || ((TARGET_LONG_ABS_CALL || local_call) && !GCC_OPTION (flag_pic))))
 	    {
 	      /* A non-jump insn in the delay slot.  By definition we can
 		 emit this insn before the call (and in fact before argument
 		 relocating.  */
-	      final_scan_insn (NEXT_INSN (insn), asm_out_file, optimize, 0,
+	      final_scan_insn (NEXT_INSN (insn), asm_out_file, GCC_OPTION (optimize), 0,
 			       NULL);
 
 	      /* Now delete the delay insn.  */
@@ -7886,7 +7886,7 @@ pa_output_call (rtx insn, rtx call_dest, int sibcall)
 	      delay_insn_deleted = 1;
 	    }
 
-	  if ((TARGET_LONG_ABS_CALL || local_call) && !flag_pic)
+	  if ((TARGET_LONG_ABS_CALL || local_call) && !GCC_OPTION (flag_pic))
 	    {
 	      /* This is the best sequence for making long calls in
 		 non-pic code.  Unfortunately, GNU ld doesn't provide
@@ -7953,7 +7953,7 @@ pa_output_call (rtx insn, rtx call_dest, int sibcall)
 		  if (TARGET_SOM)
 		    copy_fp_args (insn);
 
-		  if (flag_pic)
+		  if (GCC_OPTION (flag_pic))
 		    {
 		      output_asm_insn ("addil LT'%0,%%r19", xoperands);
 		      output_asm_insn ("ldw RT'%0(%%r1),%%r1", xoperands);
@@ -7975,7 +7975,7 @@ pa_output_call (rtx insn, rtx call_dest, int sibcall)
 		  if (!sibcall && !TARGET_PA_20)
 		    {
 		      output_asm_insn ("{bl|b,l} .+8,%%r2", xoperands);
-		      if (TARGET_NO_SPACE_REGS || (local_call && !flag_pic))
+		      if (TARGET_NO_SPACE_REGS || (local_call && !GCC_OPTION (flag_pic)))
 			output_asm_insn ("addi 8,%%r2,%%r2", xoperands);
 		      else
 			output_asm_insn ("addi 16,%%r2,%%r2", xoperands);
@@ -8000,20 +8000,20 @@ pa_output_call (rtx insn, rtx call_dest, int sibcall)
 		}
 	      else
 		{
-		  if (!TARGET_NO_SPACE_REGS && (!local_call || flag_pic))
+		  if (!TARGET_NO_SPACE_REGS && (!local_call || GCC_OPTION (flag_pic)))
 		    output_asm_insn ("ldsid (%%r1),%%r31\n\tmtsp %%r31,%%sr0",
 				     xoperands);
 
 		  if (sibcall)
 		    {
-		      if (TARGET_NO_SPACE_REGS || (local_call && !flag_pic))
+		      if (TARGET_NO_SPACE_REGS || (local_call && !GCC_OPTION (flag_pic)))
 			output_asm_insn ("be 0(%%sr4,%%r1)", xoperands);
 		      else
 			output_asm_insn ("be 0(%%sr0,%%r1)", xoperands);
 		    }
 		  else
 		    {
-		      if (TARGET_NO_SPACE_REGS || (local_call && !flag_pic))
+		      if (TARGET_NO_SPACE_REGS || (local_call && !GCC_OPTION (flag_pic)))
 			output_asm_insn ("ble 0(%%sr4,%%r1)", xoperands);
 		      else
 			output_asm_insn ("ble 0(%%sr0,%%r1)", xoperands);
@@ -8097,13 +8097,13 @@ pa_attr_length_indirect_call (rtx insn)
     return 12;
 
   if (TARGET_FAST_INDIRECT_CALLS
-      || (!TARGET_LONG_CALLS
+      || (!GCC_OPTION (TARGET_LONG_CALLS)
 	  && !TARGET_PORTABLE_RUNTIME
 	  && ((TARGET_PA_20 && !TARGET_SOM && distance < 7600000)
 	      || distance < MAX_PCREL17F_OFFSET)))
     return 8;
 
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     return 20;
 
   if (TARGET_PORTABLE_RUNTIME)
@@ -8275,10 +8275,10 @@ pa_asm_output_mi_thunk (FILE *file, tree thunk_fndecl, HOST_WIDE_INT delta,
      import stub for the target function as this could clobber the
      return value saved at SP-24.  This would also apply to the
      32-bit linux port if the multi-space model is implemented.  */
-  if ((!TARGET_LONG_CALLS && TARGET_SOM && !TARGET_PORTABLE_RUNTIME
-       && !(flag_pic && TREE_PUBLIC (function))
+  if ((!GCC_OPTION (TARGET_LONG_CALLS) && TARGET_SOM && !TARGET_PORTABLE_RUNTIME
+       && !(GCC_OPTION (flag_pic) && TREE_PUBLIC (function))
        && (TARGET_GAS || last_address < 262132))
-      || (!TARGET_LONG_CALLS && !TARGET_SOM && !TARGET_PORTABLE_RUNTIME
+      || (!GCC_OPTION (TARGET_LONG_CALLS) && !TARGET_SOM && !TARGET_PORTABLE_RUNTIME
 	  && ((targetm_common.have_named_sections
 	       && DECL_SECTION_NAME (thunk_fndecl) != NULL
 	       /* The GNU 64-bit linker has rather poor stub management.
@@ -8369,7 +8369,7 @@ pa_asm_output_mi_thunk (FILE *file, tree thunk_fndecl, HOST_WIDE_INT delta,
 	  nbytes += 20;
 	}
     }
-  else if (TARGET_SOM && flag_pic && TREE_PUBLIC (function))
+  else if (TARGET_SOM && GCC_OPTION (flag_pic) && TREE_PUBLIC (function))
     {
       /* The function is accessible from outside this module.  The only
 	 way to avoid an import stub between the thunk and function is to
@@ -8415,7 +8415,7 @@ pa_asm_output_mi_thunk (FILE *file, tree thunk_fndecl, HOST_WIDE_INT delta,
       else
 	output_asm_insn ("ldo R'%2(%%r1),%%r26", xoperands);
     }
-  else if (flag_pic)
+  else if (GCC_OPTION (flag_pic))
     {
       output_asm_insn ("{bl|b,l} .+8,%%r1", xoperands);
 
@@ -8477,7 +8477,7 @@ pa_asm_output_mi_thunk (FILE *file, tree thunk_fndecl, HOST_WIDE_INT delta,
       cfun->machine->in_nsubspa = 2;
     }
 
-  if (TARGET_SOM && flag_pic && TREE_PUBLIC (function))
+  if (TARGET_SOM && GCC_OPTION (flag_pic) && TREE_PUBLIC (function))
     {
       switch_to_section (data_section);
       output_asm_insn (".align 4", xoperands);
@@ -8964,7 +8964,7 @@ pa_reorg (void)
 
   remove_useless_addtr_insns (1);
 
-  if (pa_cpu < PROCESSOR_8000)
+  if (GCC_OPTION (pa_cpu) < PROCESSOR_8000)
     pa_combine_instructions ();
 
     /* Still need brtab marker insns.  FIXME: the presence of these
@@ -9037,7 +9037,7 @@ pa_combine_instructions (void)
   /* This can get expensive since the basic algorithm is on the
      order of O(n^2) (or worse).  Only do it for -O2 or higher
      levels of optimization.  */
-  if (optimize < 2)
+  if (GCC_OPTION (optimize) < 2)
     return;
 
   /* Walk down the list of insns looking for "anchor" insns which
@@ -9761,7 +9761,7 @@ pa_som_asm_init_sections (void)
 			   "\t.NSUBSPA $DATA$,QUAD=1,ALIGN=8,"
 			   "ACCESS=31,SORT=24,COMDAT");
 
-  if (flag_tm)
+  if (GCC_OPTION (flag_tm))
     som_tm_clone_table_section
       = get_unnamed_section (0, output_section_asm_op,
 			     "\t.SPACE $PRIVATE$\n\t.SUBSPA $TM_CLONE_TABLE$");
@@ -9778,7 +9778,7 @@ pa_som_asm_init_sections (void)
      $TEXT$ space during PIC generation.  Instead place all constant
      data into the $PRIVATE$ subspace (this reduces sharing, but it
      works correctly).  */
-  readonly_data_section = flag_pic ? data_section : som_readonly_data_section;
+  readonly_data_section = GCC_OPTION (flag_pic) ? data_section : som_readonly_data_section;
 
   /* We must not have a reference to an external symbol defined in a
      shared library in a readonly section, else the SOM linker will
@@ -10236,7 +10236,7 @@ pa_conditional_register_usage (void)
       for (i = FP_REG_FIRST; i <= FP_REG_LAST; i++)
 	fixed_regs[i] = call_used_regs[i] = 1;
     }
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     fixed_regs[PIC_OFFSET_TABLE_REGNUM] = 1;
 }
 
@@ -10538,13 +10538,13 @@ pa_legitimize_reload_address (rtx ad, enum machine_mode mode,
   mask = (GET_MODE_CLASS (mode) == MODE_FLOAT
 	  && !INT14_OK_STRICT ? 0x1f : 0x3fff);
 
-  if (optimize && GET_CODE (ad) == PLUS)
+  if (GCC_OPTION (optimize) && GET_CODE (ad) == PLUS)
     temp = simplify_binary_operation (PLUS, Pmode,
 				      XEXP (ad, 0), XEXP (ad, 1));
 
   new_rtx = temp ? temp : ad;
 
-  if (optimize
+  if (GCC_OPTION (optimize)
       && GET_CODE (new_rtx) == PLUS
       && GET_CODE (XEXP (new_rtx, 0)) == REG
       && GET_CODE (XEXP (new_rtx, 1)) == CONST_INT)
diff --git a/gcc/config/pa/pa.h b/gcc/config/pa/pa.h
index ac3f0eb..c97b207 100644
--- a/gcc/config/pa/pa.h
+++ b/gcc/config/pa/pa.h
@@ -353,7 +353,7 @@ typedef struct GTY(()) machine_function
 /* Register used to address the offset table for position-independent
    data references.  */
 #define PIC_OFFSET_TABLE_REGNUM \
-  (flag_pic ? (TARGET_64BIT ? 27 : 19) : INVALID_REGNUM)
+  (GCC_OPTION (flag_pic) ? (TARGET_64BIT ? 27 : 19) : INVALID_REGNUM)
 
 #define PIC_OFFSET_TABLE_REG_CALL_CLOBBERED 1
 
@@ -736,11 +736,11 @@ extern int may_call_alloca;
    Using autoincrement addressing modes on PA8000 class machines is
    not profitable.  */
 
-#define HAVE_POST_INCREMENT (pa_cpu < PROCESSOR_8000)
-#define HAVE_POST_DECREMENT (pa_cpu < PROCESSOR_8000)
+#define HAVE_POST_INCREMENT (GCC_OPTION (pa_cpu) < PROCESSOR_8000)
+#define HAVE_POST_DECREMENT (GCC_OPTION (pa_cpu) < PROCESSOR_8000)
 
-#define HAVE_PRE_DECREMENT (pa_cpu < PROCESSOR_8000)
-#define HAVE_PRE_INCREMENT (pa_cpu < PROCESSOR_8000)
+#define HAVE_PRE_DECREMENT (GCC_OPTION (pa_cpu) < PROCESSOR_8000)
+#define HAVE_PRE_INCREMENT (GCC_OPTION (pa_cpu) < PROCESSOR_8000)
 
 /* Macros to check register numbers against specific register classes.  */
 
@@ -979,7 +979,7 @@ do {									     \
    || (TREE_CODE (DECL) == VAR_DECL					\
        && TREE_READONLY (DECL) && ! TREE_SIDE_EFFECTS (DECL)		\
        && (! DECL_INITIAL (DECL) || ! pa_reloc_needed (DECL_INITIAL (DECL))) \
-       && !flag_pic)							\
+       && !GCC_OPTION (flag_pic))							\
    || CONSTANT_CLASS_P (DECL))
 
 #define FUNCTION_NAME_P(NAME)  (*(NAME) == '@')
@@ -1055,7 +1055,7 @@ do {									     \
 #define SHIFT_COUNT_TRUNCATED 1
 
 /* Adjust the cost of branches.  */
-#define BRANCH_COST(speed_p, predictable_p) (pa_cpu == PROCESSOR_8000 ? 2 : 1)
+#define BRANCH_COST(speed_p, predictable_p) (GCC_OPTION (pa_cpu) == PROCESSOR_8000 ? 2 : 1)
 
 /* Handling the special cases is going to get too complicated for a macro,
    just call `pa_adjust_insn_length' to do the real work.  */
@@ -1262,7 +1262,7 @@ do {									     \
     case LO_SUM:							\
       if (!symbolic_operand (XEXP (addr, 1), VOIDmode))			\
 	fputs ("R'", FILE);						\
-      else if (flag_pic == 0)						\
+      else if (GCC_OPTION (flag_pic) == 0)						\
 	fputs ("RR'", FILE);						\
       else								\
 	fputs ("RT'", FILE);						\
@@ -1307,4 +1307,4 @@ do {									     \
    not generating PIC code.  For HP-UX and ELF targets, PIC stubs are
    seven and four instructions, respectively.  */  
 #define MAX_PCREL17F_OFFSET \
-  (flag_pic ? (TARGET_HPUX ? 198164 : 221312) : 240000)
+  (GCC_OPTION (flag_pic) ? (TARGET_HPUX ? 198164 : 221312) : 240000)
diff --git a/gcc/config/pdp11/pdp11.c b/gcc/config/pdp11/pdp11.c
index 677160a..6b4d2d5 100644
--- a/gcc/config/pdp11/pdp11.c
+++ b/gcc/config/pdp11/pdp11.c
@@ -922,21 +922,21 @@ pdp11_rtx_costs (rtx x, int code, int outer_code ATTRIBUTE_UNUSED,
          as cheap as total = 2 even if we can shift!  */
       /* If optimizing for size make mult etc cheap, but not 1, so when 
          in doubt the faster insn is chosen.  */
-      if (optimize_size)
+      if (GCC_OPTION (optimize_size))
         *total = COSTS_N_INSNS (2);
       else
         *total = COSTS_N_INSNS (11);
       return false;
 
     case DIV:
-      if (optimize_size)
+      if (GCC_OPTION (optimize_size))
         *total = COSTS_N_INSNS (2);
       else
         *total = COSTS_N_INSNS (25);
       return false;
 
     case MOD:
-      if (optimize_size)
+      if (GCC_OPTION (optimize_size))
         *total = COSTS_N_INSNS (2);
       else
         *total = COSTS_N_INSNS (26);
@@ -964,7 +964,7 @@ pdp11_rtx_costs (rtx x, int code, int outer_code ATTRIBUTE_UNUSED,
     case ASHIFT:
     case LSHIFTRT:
     case ASHIFTRT:
-      if (optimize_size)
+      if (GCC_OPTION (optimize_size))
         *total = COSTS_N_INSNS (1);
       else if (GET_MODE (x) ==  QImode)
         {
@@ -1196,7 +1196,7 @@ output_block_move(rtx *operands)
     if (CONSTANT_P (operands[2]))
     {
 	if (INTVAL (operands[2]) < 16
-	    && (!optimize_size || INTVAL (operands[2]) < 5)
+	    && (!GCC_OPTION (optimize_size) || INTVAL (operands[2]) < 5)
 	    && INTVAL (operands[3]) == 1)
 	{
 	    register int i;
@@ -1207,7 +1207,7 @@ output_block_move(rtx *operands)
 	    return "";
 	}
 	else if (INTVAL(operands[2]) < 32
-		 && (!optimize_size || INTVAL (operands[2]) < 9)
+		 && (!GCC_OPTION (optimize_size) || INTVAL (operands[2]) < 9)
 		 && INTVAL (operands[3]) >= 2)
 	{
 	    register int i;
@@ -1237,7 +1237,7 @@ output_block_move(rtx *operands)
 	{
 	  lastbyte = INTVAL (operands[2]) & 1;
 
-	  if (optimize_size || INTVAL (operands[2]) & 2)
+	  if (GCC_OPTION (optimize_size) || INTVAL (operands[2]) & 2)
 	    unroll = 1;
 	  else if (INTVAL (operands[2]) & 4)
 	    unroll = 2;
@@ -1645,7 +1645,7 @@ output_addr_const_pdp11 (FILE *file, rtx x)
   switch (GET_CODE (x))
     {
     case PC:
-      gcc_assert (flag_pic);
+      gcc_assert (GCC_OPTION (flag_pic));
       putc ('.', file);
       break;
 
